Imports System.Data
Imports System.Data.OleDb
Imports System.Xml
Imports System.Xml.Xsl
Imports System.Xml.XPath

Module GlobalDB

    Public dsQuoteDataSet As DataSet
    Public dsPopQuoteDataSet As DataSet

    Public Sub LoadData()
        LoadDB()
        LoadXML()
    End Sub


    Public Sub AddNum(ByVal iCount As Integer, ByVal i As Integer, ByRef iNum() As Integer)
        Dim iTemp As Integer
        Dim j As Integer

        iTemp = Int(iCount * Rnd())

        If i = 0 Then
            iNum(i) = iTemp
        Else
            Dim fExists As Boolean

            For j = 0 To i - 1
                If iTemp = iNum(j) Then
                    fExists = True
                    Exit For
                End If
            Next

            If fExists = False Then
                iNum(i) = iTemp
            Else
                AddNum(iCount, i, iNum)
            End If
        End If
    End Sub

    Public Function GetQuote() As Quote
        Dim oQuote As New Quote()
        Dim iCount As Integer
        Dim i As Integer
        Dim myTable As New DataTable()

        myTable = dsQuoteDataSet.Tables("Quotes")
        iCount = myTable.Rows.Count
        i = Int(iCount * Rnd())

        oQuote.Name = myTable.Rows(i)("Author")
        oQuote.QuoteText = myTable.Rows(i)("Quote")
        Return oQuote

    End Function

    Private Sub LoadDB()
        dsQuoteDataSet = New DataSet()

        Dim conn As New OleDbConnection()

        Try

            conn.ConnectionString = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=C:\Book\Quotes.mdb;Persist Security Info=False"
            conn.Open()

            Try
                Dim sSQL As String = "SELECT Quote, Author FROM tblQuotes"
                Dim myAdapter As New OleDbDataAdapter(sSQL, conn)

                myAdapter.Fill(dsQuoteDataSet, "Quotes")
                conn.Close()
            Catch e As OleDbException
                Throw New Exception("An error has occured retreiving data from the Quotes Database", e)
            Catch e As Exception
                Throw New Exception("An unknown Error has occured", e)
            Catch
                Throw New Exception("An unknown Error has occured")
            End Try
        Catch e As OleDbException
            Throw New Exception("An error has occured while connecting to the Quotes Database", e)
        Catch e As Exception
            Throw New Exception("An unknown Error has occured", e)
        Catch
            Throw New Exception("An unknown Error has occured")
        End Try

    End Sub

    Private Sub LoadXML()
        dsPopQuoteDataSet = New DataSet()

        Dim myfStream As New System.IO.FileStream("C:\Book\Music.xml", System.IO.FileMode.Open)
        Dim myXmlReader As New XmlTextReader(myfStream)
        Dim myXmlReader2 As XmlReader
        Dim myDataSet As New DataSet()
        Dim myDataSet2 As New DataSet()
        Dim myTrans As New XslTransform()
        Dim myDoc As New XmlDocument()
        Dim myNav As XPathNavigator

        myDataSet.ReadXml(myXmlReader)
        myDoc.Load("C:\Book\Sports.xml")
        myTrans.Load("C:\Book\Sports.xslt")
        myNav = myDoc.CreateNavigator

        myXmlReader2 = myTrans.Transform(myNav, Nothing)

        myDataSet2.ReadXml(myXmlReader2)

        dsPopQuoteDataSet.Tables.Add(myDataSet.Tables(0).Copy)
        dsPopQuoteDataSet.Tables.Add(myDataSet2.Tables(0).Copy)

        myXmlReader.Close()
        myXmlReader2.Close()

    End Sub
End Module
