Imports System.Web.Services

Public Class PopQuotes
    Inherits System.Web.Services.WebService

#Region " Web Services Designer Generated Code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Web Services Designer.
        InitializeComponent()

        'Add your own initialization code after the InitializeComponent() call

    End Sub

    'Required by the Web Services Designer
    Private components As System.ComponentModel.Container

    'NOTE: The following procedure is required by the Web Services Designer
    'It can be modified using the Web Services Designer.  
    'Do not modify it using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        components = New System.ComponentModel.Container()
    End Sub

    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        'CODEGEN: This procedure is required by the Web Services Designer
        'Do not modify it using the code editor.
    End Sub

#End Region

    Public Enum QuoteType
        Music = 0
        Sports = 1
    End Enum

    <WebMethod(Description:="Provides a new random quote everytime that it is called.")> _
     Public Function RandomQuote(ByVal Style As QuoteType) As Quote
        Dim oQuote As New Quote()
        Dim iCount As Integer
        Dim i As Integer
        Dim myTable As New DataTable()

        myTable = dsPopQuoteDataSet.Tables(Style)
        iCount = myTable.Rows.Count
        i = Int(iCount * Rnd())

        oQuote.Name = myTable.Rows(i)("Author")
        oQuote.QuoteText = myTable.Rows(i)("Text")
        Return oQuote

    End Function

    <WebMethod(MessageName:="AllQuotes", _
    Description:="Returns the full list of quotes")> _
    Public Function QuoteList(ByVal Style As QuoteType) As DataSet
        Dim myDataSet As New DataSet()
        Dim myTable As New DataTable()

        myTable = dsPopQuoteDataSet.Tables(Style).Copy
        myDataSet.Tables.Add(myTable)

        Return myDataSet
    End Function

    <WebMethod(MessageName:="NumberQuotes", _
   Description:="Returns between 1 and 10 randomly selected quotes")> _
   Public Function QuoteList(ByVal QuoteNumber As Integer, ByVal Style As QuoteType) As DataSet
        Dim iCount As Integer
        Dim myDataSet As New DataSet()
        Dim myTable As New DataTable()

        If (0 >= QuoteNumber) Or (QuoteNumber > 10) Then
            Throw New IndexOutOfRangeException("QuoteList Requires an Integer Value between 1 and 10")
        End If

        myTable = dsPopQuoteDataSet.Tables(Style)
        iCount = myTable.Rows.Count

        If iCount <= QuoteNumber Then
            myDataSet = dsPopQuoteDataSet.Copy
        Else
            myDataSet = dsPopQuoteDataSet.Clone

            Dim i As Integer
            Dim j As Integer
            Dim iNum(QuoteNumber - 1) As Integer
            Dim myRow As DataRow
            Dim myTable2 As New DataTable()

            myTable2 = myDataSet.Tables(Style)

            For i = 0 To QuoteNumber - 1
                AddNum(iCount, i, iNum)

                myRow = myTable2.NewRow

                myRow("Author") = myTable.Rows(iNum(i))("Author")
                myRow("Text") = myTable.Rows(iNum(i))("Text")
                myTable2.Rows.Add(myRow)
            Next

        End If


        Return myDataSet
    End Function

    <WebMethod(EnableSession:=True, _
     Description:="Returns the same quote throughout the life of the object")> _
     Public Function SessionQuote(ByVal Style As QuoteType) As Quote
        Dim oQuote As New Quote()

        If Session("Quote") Is Nothing Then
            oQuote = RandomQuote(Style)
            Session("Author") = oQuote.Name
            Session("Quote") = oQuote.QuoteText
        Else
            oQuote.Name = Session("Author")
            oQuote.QuoteText = Session("Quote")
        End If

        Return oQuote
    End Function
End Class
